AbstractService
Date: 2016-05-24

com.google.common.util.concurrent

## Class AbstractService

- java.lang.Object
- - com.google.common.util.concurrent.AbstractService

- All Implemented Interfaces:
    Service

      @Beta
      public abstract class AbstractService
      extends java.lang.Object
      implements Service

  Base class for implementing services that can handle `doStart()` and `doStop()` requests, responding to them with `notifyStarted()` and `notifyStopped()` callbacks. Its subclasses must manage threads manually; consider `AbstractExecutionThreadService` if you need only a single execution thread.
  Since:
    1.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.google.common.util.concurrent.Service

      `Service.Listener, Service.State`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractService()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(Service.Listener listener, java.util.concurrent.Executor executor)` Registers a `Service.Listener` to be executed on the given executor.
    `void` | `awaitRunning()` Waits for the `Service` to reach the running state.
    `void` | `awaitRunning(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach the running state for no more than the given time.
    `void` | `awaitTerminated()` Waits for the `Service` to reach the terminated state.
    `void` | `awaitTerminated(long timeout, java.util.concurrent.TimeUnit unit)` Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
    `protected abstract void` | `doStart()` This method is called by `startAsync()` to initiate service startup.
    `protected abstract void` | `doStop()` This method should be used to initiate service shutdown.
    `java.lang.Throwable` | `failureCause()` Returns the `Throwable` that caused this service to fail.
    `boolean` | `isRunning()` Returns `true` if this service is running.
    `protected void` | `notifyFailed(java.lang.Throwable cause)` Invoke this method to transition the service to the `Service.State.FAILED`.
    `protected void` | `notifyStarted()` Implementing classes should invoke this method once their service has started.
    `protected void` | `notifyStopped()` Implementing classes should invoke this method once their service has stopped.
    `Service` | `startAsync()` If the service state is `Service.State.NEW`, this initiates service startup and returns immediately.
    `Service.State` | `state()` Returns the lifecycle state of the service.
    `Service` | `stopAsync()` If the service is starting or running, this initiates service shutdown and returns immediately.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractService

          protected AbstractService()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### doStart

          protected abstract void doStart()

      This method is called by `startAsync()` to initiate service startup. The invocation of this method should cause a call to `notifyStarted()`, either during this method's run, or after it has returned. If startup fails, the invocation should cause a call to `notifyFailed(Throwable)` instead.

      This method should return promptly; prefer to do work on a different thread where it is convenient. It is invoked exactly once on service startup, even when `startAsync()` is called multiple times.

    - #### doStop

          protected abstract void doStop()

      This method should be used to initiate service shutdown. The invocation of this method should cause a call to `notifyStopped()`, either during this method's run, or after it has returned. If shutdown fails, the invocation should cause a call to `notifyFailed(Throwable)` instead.

      This method should return promptly; prefer to do work on a different thread where it is convenient. It is invoked exactly once on service shutdown, even when `stopAsync()` is called multiple times.

    - #### startAsync

          public final Service startAsync()

      Description copied from interface: `Service`
      If the service state is `Service.State.NEW`, this initiates service startup and returns immediately. A stopped service may not be restarted.
      Specified by:
        `startAsync` in interface `Service`
      Returns:
        this

    - #### stopAsync

          public final Service stopAsync()

      Description copied from interface: `Service`
      If the service is starting or running, this initiates service shutdown and returns immediately. If the service is new, it is terminated without having been started nor stopped. If the service has already been stopped, this method returns immediately without taking action.
      Specified by:
        `stopAsync` in interface `Service`
      Returns:
        this

    - #### awaitRunning

          public final void awaitRunning()

      Description copied from interface: `Service`
      Waits for the `Service` to reach the running state.
      Specified by:
        `awaitRunning` in interface `Service`

    - #### awaitRunning

          public final void awaitRunning(long timeout,
                          java.util.concurrent.TimeUnit unit)
                                  throws java.util.concurrent.TimeoutException

      Description copied from interface: `Service`
      Waits for the `Service` to reach the running state for no more than the given time.
      Specified by:
        `awaitRunning` in interface `Service`
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline

    - #### awaitTerminated

          public final void awaitTerminated()

      Description copied from interface: `Service`
      Waits for the `Service` to reach the terminated state.
      Specified by:
        `awaitTerminated` in interface `Service`

    - #### awaitTerminated

          public final void awaitTerminated(long timeout,
                             java.util.concurrent.TimeUnit unit)
                                     throws java.util.concurrent.TimeoutException

      Description copied from interface: `Service`
      Waits for the `Service` to reach a terminal state (either `terminated` or `failed`) for no more than the given time.
      Specified by:
        `awaitTerminated` in interface `Service`
      Parameters:
        `timeout` - the maximum time to wait
        `unit` - the time unit of the timeout argument
      Throws:
        `java.util.concurrent.TimeoutException` - if the service has not reached the given state within the deadline

    - #### notifyStarted

          protected final void notifyStarted()

      Implementing classes should invoke this method once their service has started. It will cause the service to transition from `Service.State.STARTING` to `Service.State.RUNNING`.
      Throws:
        `java.lang.IllegalStateException` - if the service is not `Service.State.STARTING`.

    - #### notifyStopped

          protected final void notifyStopped()

      Implementing classes should invoke this method once their service has stopped. It will cause the service to transition from `Service.State.STOPPING` to `Service.State.TERMINATED`.
      Throws:
        `java.lang.IllegalStateException` - if the service is neither `Service.State.STOPPING` nor `Service.State.RUNNING`.

    - #### notifyFailed

          protected final void notifyFailed(java.lang.Throwable cause)

      Invoke this method to transition the service to the `Service.State.FAILED`. The service will not be stopped if it is running. Invoke this method when a service has failed critically or otherwise cannot be started nor stopped.

    - #### isRunning

          public final boolean isRunning()

      Description copied from interface: `Service`
      Returns `true` if this service is running.
      Specified by:
        `isRunning` in interface `Service`

    - #### state

          public final Service.State state()

      Description copied from interface: `Service`
      Returns the lifecycle state of the service.
      Specified by:
        `state` in interface `Service`

    - #### failureCause

          public final java.lang.Throwable failureCause()

      Description copied from interface: `Service`
      Returns the `Throwable` that caused this service to fail.
      Specified by:
        `failureCause` in interface `Service`
      Since:
        14.0

    - #### addListener

          public final void addListener(Service.Listener listener,
                         java.util.concurrent.Executor executor)

      Description copied from interface: `Service`
      Registers a `Service.Listener` to be executed on the given executor. The listener will have the corresponding transition method called whenever the service changes state. The listener will not have previous state changes replayed, so it is suggested that listeners are added before the service starts.

      `addListener` guarantees execution ordering across calls to a given listener but not across calls to multiple listeners. Specifically, a given listener will have its callbacks invoked in the same order as the underlying service enters those states. Additionally, at most one of the listener's callbacks will execute at once. However, multiple listeners' callbacks may execute concurrently, and listeners may execute in an order different from the one in which they were registered.

      RuntimeExceptions thrown by a listener will be caught and logged. Any exception thrown during `Executor.execute` (e.g., a `RejectedExecutionException`) will be caught and logged.

      Specified by:
        `addListener` in interface `Service`
      Parameters:
        `listener` - the listener to run when the service changes state is complete
        `executor` - the executor in which the listeners callback methods will be run. For fast, lightweight listeners that would be safe to execute in any thread, consider `MoreExecutors.directExecutor()`.
      Since:
        13.0

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`